/**
 * Copyright (c) 2010-2012 EBM WebSourcing, 2012-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
package com.ebmwebsourcing.easycommons.time;

import org.junit.Test;

import static org.junit.Assert.assertTrue;

/**
 * @author Mathieu CARROLLE - EBM WebSourcing
 */
public class SimulatedTimeTest {

    @Test
    public void testUtcTimeVariation() throws InterruptedException {
        SimulatedTime time = new SimulatedTime();
        long utcTime1 = time.getUtcTime();
        Thread.sleep(5);
        long utcTime2 = time.getUtcTime();
        assertTrue(utcTime1 < utcTime2);
    }

    @Test
    public void testUtcTimePause() throws InterruptedException {
        SimulatedTime time1 = new SimulatedTime();
        time1.pause();
        long utcTime1 = time1.getUtcTime();
        // wait 5milli
        Thread.sleep(5);
        long utcTime2 = time1.getUtcTime();
        assertTrue(utcTime1 == utcTime2);
    }

    @Test
    public void testUtcTimeResume() throws InterruptedException {
        SimulatedTime time1 = new SimulatedTime();
        time1.pause();
        long utcTime1 = time1.getUtcTime();
        Thread.sleep(5);
        long utcTime2 = time1.getUtcTime();
        assertTrue(utcTime1 == utcTime2);

        time1.resume();
        long utcTime3 = time1.getUtcTime();
        Thread.sleep(5);
        long utcTime4 = time1.getUtcTime();
        assertTrue(utcTime3 < utcTime4);

    }
}
